from PIL import Image
from pathlib import Path
import os

##руная настройка
cor_plus = 1.25##для ручной подстройки корректировки узких исходных фото


current_path = os.path.dirname(os.path.abspath(__file__)) + '/'  ##любая папка где размещен этот скрипт
size_x = 1000 ## какая требуется ширина у новой фотографии
size_y = 300

r = 255##фон
g = 255
b = 255
cor=0

# создать папку out
path_Out = os.path.join("out")
if os.path.exists(path_Out):
    pq = 8##пустышка
else:
    os.makedirs(path_Out)

path_Out = os.path.join("out") + '/'

##сканируем current_path
files_name = []# Создаем пустой список
files_name = os.listdir(current_path)# получаем список имен файлов в папке
for file_name in files_name:# проходим циклом по списку имен файлов в папке
    ## Изменение размера изображения
    file_name_suffix = Path(file_name).suffix## получаем расширение файла
    if file_name_suffix =='.jpg' or file_name_suffix =='.png' or file_name_suffix =='.webp':## филтруем карики
        img = Image.open(current_path + file_name)
        format_img = img.format  ## 'JPEG'
        size_img = img.size  ##(1920, 1273)
        mode_img = img.mode  ## 'RGB'
        size_img_x = size_img[0]
        size_img_y = size_img[1]
        size_proportion_x = size_x / size_y
        size_proportion_y = size_y / size_x
        ## Обрезка изображения
        cut_plus_x = 0
        cut_plus_y = 0
        cut_plus = 0
        if size_x < size_y:##если у заданых пропорций высота больше ширины
            img_cut_width = round(size_img_y * size_proportion_x) ##ширина заплатки ##round округлить
            img_cut_height = size_img_y  ##высота заплатки
            cor = 0
            if size_img_x < size_img_y:##поправка длч узких картинок
                cor = round(((size_x / size_y)-(size_img_x / size_img_y))*(size_y * cor_plus))
                print(size_img_x, '<', size_img_y)

        else:
            img_cut_width = size_img_x ##ширина заплатки ##round округлить
            img_cut_height = round(size_img_x * size_proportion_y)##высота заплатки ##round округлить

        cut_slice_x = round((size_img_x - img_cut_width)/2) ## 1/2 ширины обрезков
        cut_slice_y = round((size_img_y - img_cut_height)/2)  ## 1/2 высота обрезков
        img = img.crop((cut_slice_x, cut_slice_y, img_cut_width + cut_slice_x, img_cut_height + cut_slice_y))

        # ## Изменение размера изображения
        new_size = (size_x + cor, size_y+cor)
        img = img.resize(new_size)

        background = Image.new('RGB', (size_x, size_y), (r, g, b))
        background.paste(img, (round(cor/-2), 0))
        ## сохраняем
        background.save(path_Out + file_name)







# print(format_img, size_img, mode_img)
# print(size_img_x)
# print(size_img_y)





